OGRE: Ogre::StaticGeometry::Region Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::StaticGeometry::Region Class Reference

The details of a topological region which is the highest level of partitioning for this class. More...

`#include <OgreStaticGeometry.h>`

Inheritance diagram for Ogre::StaticGeometry::Region:

[legend]
List of all members.

## Public Types

typedef std::vector< LODBucket * > | LODBucketList
| list of LOD Buckets in this region
typedef VectorIterator< LODBucketList > | LODIterator
typedef std::vector< ShadowRenderable * > | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator

## Public Member Functions

| Region (StaticGeometry *parent, const String &name, SceneManager *mgr, uint32 regionID, const Vector3 &centre)
virtual | ~Region ()
StaticGeometry * | getParent (void) const
void | assign (QueuedSubMesh *qmesh)
| Assign a queued mesh to this region, read for final build.
void | build (bool stencilShadows)
| Build this region.
uint32 | getID (void) const
| Get the region ID of this region.
const Vector3 & | getCentre (void) const
| Get the centre point of the region.
const String & | getMovableType (void) const
| Returns the type name of this object.
void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
const AxisAlignedBox & | getBoundingBox (void) const
| Retrieves the local axis-aligned bounding box for this object.
Real | getBoundingRadius (void) const
| Retrieves the radius of the origin-centered bounding sphere for this object.
void | _updateRenderQueue (RenderQueue *queue)
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
LODIterator | getLODIterator (void)
| Get an iterator over the LODs in this region.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDistance, unsigned long flags=0)

Remarks:
  Shadowable geometry should ideally be designed such that there is only one ShadowRenderable required to render the the shadow; however this is not a necessary limitation and it can be exceeded if required.

Parameters:

  | shadowTechnique | The technique being used to generate the shadow
  | light | The light to generate the shadow from
  | indexBuffer | The index buffer to build the renderables into, the current contents are assumed to be disposable.
  | extrudeVertices | If true, this means this class should extrude the vertices of the back of the volume in software. If false, it will not be done (a vertex program is assumed).
  | extrusionDistance | The distance to extrude the shadow volume
  | flags | Technique-specific flags, see ShadowRenderableFlags

EdgeData * | getEdgeList (void)
| Overridden from MovableObject.
bool | hasEdgeList (void)
| Overridden member from ShadowCaster.
void | dump (std::ofstream &of) const
| Dump contents for diagnostics.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const String & | getName (void) const
| Returns the name of this object.
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
virtual void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserObject (UserDefinedObject *obj)
| Call this to associate your own custom user object instance with this MovableObject.
virtual UserDefinedObject * | getUserObject (void)
| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.

## Static Public Member Functions

static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Protected Types

typedef std::map< String, StringVector > | AnimableDictionaryMap

## Protected Member Functions

Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper moethod for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
virtual const String & | getAnimableDictionaryName (void) const
| Get the name of the animable dictionary for this class.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.
virtual void | initialiseAnimableDictionary (StringVector &) const
| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.

## Protected Attributes

StaticGeometry * | mParent
| Parent static geometry.
SceneManager * | mSceneMgr
| Scene manager link.
SceneNode * | mNode
| Scene node.
QueuedSubMeshList | mQueuedSubMeshes
| Local list of queued meshes (not used for deallocation).
uint32 | mRegionID
| Unique identifier for the region.
Vector3 | mCentre
| Center of the region.
std::vector< Real > | mLodSquaredDistances
| LOD distances (squared) as built up - use the max at each level.
AxisAlignedBox | mAABB
| Local AABB relative to region centre.
Real | mBoundingRadius
| Local bounding radius.
ushort | mCurrentLod
| The current lod level, as determined from the last camera.
Real | mCamDistanceSquared
| Current camera distance, passed on to do material lod later.
LODBucketList | mLodBucketList
| List of LOD buckets.
LightList | mLightList
| List of lights for this region.
ulong | mLightListUpdated
| The last frame that this light list was updated in.
EdgeData * | mEdgeList
| Edge list, used if stencil shadow casting is enabled.
ShadowRenderableList | mShadowRenderables
| List of shadow renderables.
bool | mVertexProgramInUse
| Is a vertex program in use somewhere in this region?
String | mName
| Name of this object.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
Any | mUserAny
| User defined link to another object / value / whatever.
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
AxisAlignedBox | mWorldAABB
| Cached world AABB of this object.
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.

## Static Protected Attributes

static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.

## Classes

class | RegionShadowRenderable
| Nested class to allow region shadows. More...

## Detailed Description

The details of a topological region which is the highest level of partitioning for this class.

Remarks:
  The size & shape of regions entirely depends on the SceneManager specific implementation. It is a MovableObject since it will be attached to a node based on the local centre - in practice it won't actually move (although in theory it could).

Definition at line 348 of file OgreStaticGeometry.h.

## Member Typedef Documentation

typedef std::map<String, StringVector> Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

| Definition at line 206 of file OgreAnimable.h.

typedef std::vector<LODBucket*> Ogre::StaticGeometry::Region::LODBucketList

| list of LOD Buckets in this region Definition at line 352 of file OgreStaticGeometry.h.

typedef VectorIterator<LODBucketList> Ogre::StaticGeometry::Region::LODIterator

| Definition at line 438 of file OgreStaticGeometry.h.

typedef std::vector<ShadowRenderable*> Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

| Definition at line 127 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

| Definition at line 128 of file OgreShadowCaster.h.

## Constructor & Destructor Documentation

Ogre::StaticGeometry::Region::Region | ( | StaticGeometry * | parent,
|  | const String & | name,
|  | SceneManager * | mgr,
|  | uint32 | regionID,
|  | const Vector3 & | centre
| ) |

virtual Ogre::StaticGeometry::Region::~Region | ( |  | ) | `[virtual]`

## Member Function Documentation

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

| Get an updateable reference to animable value list. Definition at line 232 of file OgreAnimable.h. References OGRE_EXCEPT.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

| Get the creator of this object, if any (internal use only). Definition at line 166 of file OgreMovableObject.h.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

| Get the manager of this object, if any (internal use only). Definition at line 170 of file OgreMovableObject.h.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

| return the full transformation of the parent sceneNode or the attachingPoint node

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false`
| ) | `[virtual, inherited]`

| Internal method called to notify the object that it has been attached to a node. Reimplemented in Ogre::Entity, Ogre::Light, and Ogre::ParticleSystem.

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

| Notify the object of it's creator (internal use only). Definition at line 164 of file OgreMovableObject.h.

void Ogre::StaticGeometry::Region::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual]`

Internal method to notify the object of the camera to be used for the next rendering operation.

Remarks:
  Certain objects may want to do specific processing based on the camera position. This method notifies them incase they wish to do this.

Reimplemented from Ogre::MovableObject.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

| Notify the object of it's manager (internal use only). Definition at line 168 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyMoved | ( | void |  | ) | `[virtual, inherited]`

| Internal method called to notify the object that it has been moved. Reimplemented in Ogre::Light.

void Ogre::StaticGeometry::Region::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual]`

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

Remarks:
  The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implements Ogre::MovableObject.

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 338 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 366 of file OgreMovableObject.h.

void Ogre::StaticGeometry::Region::assign | ( | QueuedSubMesh * | qmesh | ) |

| Assign a queued mesh to this region, read for final build.

void Ogre::StaticGeometry::Region::build | ( | bool | stencilShadows | ) |

| Build this region.

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

| Internal method for creating a dictionary of animable value names for the class, if it does not already exist. Definition at line 219 of file OgreAnimable.h.

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) | `[virtual, inherited]`

Create a reference-counted AnimableValuePtr for the named value.

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 285 of file OgreAnimable.h.

References OGRE_EXCEPT.

void Ogre::StaticGeometry::Region::dump | ( | std::ofstream & | of | ) | const

| Dump contents for diagnostics.

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | const`[protected, virtual, inherited]`

Utility method for extruding a bounding box.

Parameters:

  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | `[static, inherited]`

Utility method for extruding vertices based on a light.

Remarks:
  Unfortunately, because D3D cannot handle homogenous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this.

Parameters:

  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, ie the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags
| ) | `[protected, virtual, inherited]`

Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.

Parameters:

  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

virtual const String& Ogre::AnimableObject::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual, inherited]`

Get the name of the animable dictionary for this class.

Remarks:
  Subclasses must override this if they want to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 214 of file OgreAnimable.h.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

| Gets a list of animable value names for this object. Definition at line 260 of file OgreAnimable.h. References OGRE_EXCEPT.

const AxisAlignedBox& Ogre::StaticGeometry::Region::getBoundingBox | ( | void |  | ) | const`[virtual]`

Retrieves the local axis-aligned bounding box for this object.

Remarks:
  This bounding box is in local coordinates.

Implements Ogre::MovableObject.

Real Ogre::StaticGeometry::Region::getBoundingRadius | ( | void |  | ) | const`[virtual]`

| Retrieves the radius of the origin-centered bounding sphere for this object. Implements Ogre::MovableObject.

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether shadow casting is enabled for this object. Implements Ogre::ShadowCaster. Definition at line 442 of file OgreMovableObject.h.

const Vector3& Ogre::StaticGeometry::Region::getCentre | ( | void |  | ) | const

| Get the centre point of the region. Definition at line 429 of file OgreStaticGeometry.h.

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist
| ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

| Get the default query flags for all future MovableObject instances. Definition at line 353 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

| Get the default visibility flags for all future MovableObject instances. Definition at line 381 of file OgreMovableObject.h.

EdgeData* Ogre::StaticGeometry::Region::getEdgeList | ( | void |  | ) | `[virtual]`

| Overridden from MovableObject. Reimplemented from Ogre::MovableObject.

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light
| ) | const`[protected, inherited]`

| Helper moethod for calculating extrusion distance.

uint32 Ogre::StaticGeometry::Region::getID | ( | void |  | ) | const

| Get the region ID of this region. Definition at line 427 of file OgreStaticGeometry.h.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

| Gets the current listener for this object. Definition at line 392 of file OgreMovableObject.h.

LODIterator Ogre::StaticGeometry::Region::getLODIterator | ( | void |  | ) |

| Get an iterator over the LODs in this region.

const String& Ogre::StaticGeometry::Region::getMovableType | ( | void |  | ) | const`[virtual]`

| Returns the type name of this object. Implements Ogre::MovableObject.

virtual const String& Ogre::MovableObject::getName | ( | void |  | ) | const`[virtual, inherited]`

| Returns the name of this object. Reimplemented in Ogre::Camera. Definition at line 173 of file OgreMovableObject.h.

StaticGeometry* Ogre::StaticGeometry::Region::getParent | ( | void |  | ) | const

| Definition at line 421 of file OgreStaticGeometry.h.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the scene node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[virtual, inherited]`

| Get the distance to extrude for a point/spot light. Implements Ogre::ShadowCaster.

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the query flags relevant for this object. Definition at line 345 of file OgreMovableObject.h.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

| Gets the distance at which batches are no longer rendered. Definition at line 278 of file OgreMovableObject.h.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

| Gets the queue group for this entity, see setRenderQueueGroup for full details.

ShadowRenderableListIterator Ogre::StaticGeometry::Region::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDistance,
|  | unsigned long | flags = `0`
| ) | `[virtual]`

Remarks:
  Shadowable geometry should ideally be designed such that there is only one ShadowRenderable required to render the the shadow; however this is not a necessary limitation and it can be exceeded if required.

Parameters:

  | shadowTechnique | The technique being used to generate the shadow
  | light | The light to generate the shadow from
  | indexBuffer | The index buffer to build the renderables into, the current contents are assumed to be disposable.
  | extrudeVertices | If true, this means this class should extrude the vertices of the back of the volume in software. If false, it will not be done (a vertex program is assumed).
  | extrusionDistance | The distance to extrude the shadow volume
  | flags | Technique-specific flags, see ShadowRenderableFlags

Reimplemented from Ogre::MovableObject.

uint32 Ogre::StaticGeometry::Region::getTypeFlags | ( | void |  | ) | const`[virtual]`

Get the 'type flags' for this MovableObject.

Remarks:
  A type flag identifies the type of the MovableObject as a bitpattern. This is used for categorical inclusion / exclusion in SceneQuery objects. By default, this method returns all ones for objects not created by a MovableObjectFactory (hence always including them); otherwise it returns the value assigned to the MovableObjectFactory. Custom objects which don't use MovableObjectFactory will need to override this if they want to be included in queries.

Reimplemented from Ogre::MovableObject.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves the custom user value associated with this object. Definition at line 306 of file OgreMovableObject.h.

virtual UserDefinedObject* Ogre::MovableObject::getUserObject | ( | void |  | ) | `[virtual, inherited]`

| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject. Definition at line 290 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the visibility flags relevant for this object. Definition at line 373 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

Gets this object whether to be visible or not, if it has a renderable component.

Remarks:
  Returns the value set by MovableObject::setVisible only.

virtual const AxisAlignedBox& Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the axis-aligned bounding box for this object in world coordinates. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity.

virtual const Sphere& Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the worldspace bounding sphere for this object. Reimplemented in Ogre::Entity.

bool Ogre::StaticGeometry::Region::hasEdgeList | ( | void |  | ) | `[virtual]`

| Overridden member from ShadowCaster. Reimplemented from Ogre::MovableObject.

virtual void Ogre::AnimableObject::initialiseAnimableDictionary | ( | StringVector & |  | ) | const`[protected, virtual, inherited]`

| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters. Reimplemented in Ogre::Light. Definition at line 252 of file OgreAnimable.h.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint.

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

bool Ogre::StaticGeometry::Region::isVisible | ( | void |  | ) | const`[virtual]`

Returns whether or not this object is supposed to be visible or not.

Remarks:
  Takes into account both upper rendering distance and visible flag.

Reimplemented from Ogre::MovableObject.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks:
  By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list.

  The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed (

See also:
  SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance.

  This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable.

Returns:
  The list of lights use to lighting this object.

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 342 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 370 of file OgreMovableObject.h.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

Sets whether or not this object will cast shadows.

Remarks:
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note:
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

Definition at line 440 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default query flags for all future MovableObject instances. Definition at line 349 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default visibility flags for all future MovableObject instances. Definition at line 377 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this object.

Remarks:
  Note for size and performance reasons only one listener per object is allowed.

Definition at line 388 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the query flags for this object.

Remarks:
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

Definition at line 334 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

Sets the distance at which the object is no longer rendered.

Parameters:

  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).

Definition at line 272 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual, inherited]`

Sets the render queue group this entity will be rendered through.

Remarks:
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters:

  | queueID | Enumerated value of the queue group to use.

Reimplemented in Ogre::Entity, and Ogre::ParticleSystem.

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance.

Note:
  This value is shared with setUserObject so don't use both!

Definition at line 302 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setUserObject | ( | UserDefinedObject * | obj | ) | `[virtual, inherited]`

Call this to associate your own custom user object instance with this MovableObject.

Remarks:
  By simply making your game / application object a subclass of UserDefinedObject, you can establish a link between an OGRE instance of MovableObject and your own application classes. Call this method to establish the link.

Definition at line 286 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the visiblity flags for this object.

Remarks:
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible.

Definition at line 362 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisible | ( | bool | visible | ) | `[virtual, inherited]`

Tells this object whether to be visible or not, if it has a renderable component.

Note:
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visbility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visbility changes are best done using this method; large or more longer term changes are best done by detaching.

Reimplemented in Ogre::Light.

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos
| ) | `[protected, virtual, inherited]`

Tells the caster to perform the tasks necessary to update the edge data's light listing.

Can be overridden if the subclass needs to do additional things.

Parameters:

  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

## Member Data Documentation

AxisAlignedBox Ogre::StaticGeometry::Region::mAABB`[protected]`

| Local AABB relative to region centre. Definition at line 394 of file OgreStaticGeometry.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

| Hidden because of distance? Definition at line 115 of file OgreMovableObject.h.

Real Ogre::StaticGeometry::Region::mBoundingRadius`[protected]`

| Local bounding radius. Definition at line 396 of file OgreStaticGeometry.h.

Real Ogre::StaticGeometry::Region::mCamDistanceSquared`[protected]`

| Current camera distance, passed on to do material lod later. Definition at line 400 of file OgreStaticGeometry.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

| Does this object cast shadows? Definition at line 133 of file OgreMovableObject.h.

Vector3 Ogre::StaticGeometry::Region::mCentre`[protected]`

| Center of the region. Definition at line 390 of file OgreStaticGeometry.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

| Creator of this object (if created by a factory). Definition at line 103 of file OgreMovableObject.h.

ushort Ogre::StaticGeometry::Region::mCurrentLod`[protected]`

| The current lod level, as determined from the last camera. Definition at line 398 of file OgreStaticGeometry.h.

EdgeData* Ogre::StaticGeometry::Region::mEdgeList`[protected]`

| Edge list, used if stencil shadow casting is enabled. Definition at line 408 of file OgreStaticGeometry.h.

LightList Ogre::StaticGeometry::Region::mLightList`[mutable, protected]`

| List of lights for this region. Reimplemented from Ogre::MovableObject. Definition at line 404 of file OgreStaticGeometry.h.

ulong Ogre::StaticGeometry::Region::mLightListUpdated`[mutable, protected]`

| The last frame that this light list was updated in. Reimplemented from Ogre::MovableObject. Definition at line 406 of file OgreStaticGeometry.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

| MovableObject listener - only one allowed (no list) for size & performance reasons. */. Definition at line 138 of file OgreMovableObject.h.

LODBucketList Ogre::StaticGeometry::Region::mLodBucketList`[protected]`

| List of LOD buckets. Definition at line 402 of file OgreStaticGeometry.h.

std::vector<Real> Ogre::StaticGeometry::Region::mLodSquaredDistances`[protected]`

| LOD distances (squared) as built up - use the max at each level. Definition at line 392 of file OgreStaticGeometry.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

| SceneManager holding this object (if applicable). Definition at line 105 of file OgreMovableObject.h.

String Ogre::MovableObject::mName`[protected, inherited]`

| Name of this object. Reimplemented in Ogre::Camera. Definition at line 101 of file OgreMovableObject.h.

SceneNode* Ogre::StaticGeometry::Region::mNode`[protected]`

| Scene node. Definition at line 384 of file OgreStaticGeometry.h.

StaticGeometry* Ogre::StaticGeometry::Region::mParent`[protected]`

| Parent static geometry. Definition at line 380 of file OgreStaticGeometry.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

| Definition at line 108 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

| node to which this object is attached Definition at line 107 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

| Flags determining whether this object is included / excluded from scene queries. Definition at line 123 of file OgreMovableObject.h.

QueuedSubMeshList Ogre::StaticGeometry::Region::mQueuedSubMeshes`[protected]`

| Local list of queued meshes (not used for deallocation). Definition at line 386 of file OgreStaticGeometry.h.

uint32 Ogre::StaticGeometry::Region::mRegionID`[protected]`

| Unique identifier for the region. Definition at line 388 of file OgreStaticGeometry.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

| Does rendering this object disabled by listener? Definition at line 136 of file OgreMovableObject.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

| The render queue to use when rendering this object. Definition at line 119 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

| Flags whether the RenderQueue's default should be used. Definition at line 121 of file OgreMovableObject.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

| Static map of class name to list of animable value names. Definition at line 208 of file OgreAnimable.h.

SceneManager* Ogre::StaticGeometry::Region::mSceneMgr`[protected]`

| Scene manager link. Definition at line 382 of file OgreStaticGeometry.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

| Default query flags. Definition at line 147 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

| Default visibility flags. Definition at line 149 of file OgreMovableObject.h.

ShadowRenderableList Ogre::StaticGeometry::Region::mShadowRenderables`[protected]`

| List of shadow renderables. Definition at line 410 of file OgreStaticGeometry.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

| Definition at line 113 of file OgreMovableObject.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

| Upper distance to still render. Definition at line 112 of file OgreMovableObject.h.

Any Ogre::MovableObject::mUserAny`[protected, inherited]`

| User defined link to another object / value / whatever. Definition at line 117 of file OgreMovableObject.h.

bool Ogre::StaticGeometry::Region::mVertexProgramInUse`[protected]`

| Is a vertex program in use somewhere in this region? Definition at line 412 of file OgreStaticGeometry.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

| Flags determining whether this object is visible (compared to SceneManager mask). Definition at line 125 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

| Is this object visible? Definition at line 110 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldAABB`[mutable, protected, inherited]`

| Cached world AABB of this object. Reimplemented in Ogre::ParticleSystem. Definition at line 127 of file OgreMovableObject.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

| Definition at line 129 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

| World space AABB of this object's dark cap. Definition at line 131 of file OgreMovableObject.h.

The documentation for this class was generated from the following file:

- OgreStaticGeometry.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:11 2008